(*
Copyright (C) 1999 Grischa Brockhaus <skullsoft@grischa.de>
modified      1999 Andre Grueneberg <andre@grueneberg.de>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*)

program timPGP;
uses
     {$Ifdef Windows}
     Windos, WinCrt,
     {$Else}
     Dos, Crt,
     {$Endif}
     Share, UString, XDos, MTask, XBitStr, XDaTime
     {$IfNDef VirtualPascal}
     ,FSwap,redir,lfn
     {$Else}
     ,Use32
     {$EndIf}
     ;

{$I compiled.inc}

const
    strPgp     : String = 'PGP.EXE';
    strMantra  : String = '';
    parMantra  : String = '';
    strPUBRING : String = '';
    strPubID   : String = 'pub';
    strTrigger : String = '';
    strEncrID  : String = '';
    strAskUser : String = '';
    Version     = '1.1';

    parenc      : String = '-eta [infile] [to] -o [outfile]';
    parsig      : String = '-sta [infile] -o [outfile] +clearsig=on';
    parencsig   : String = '-eas [infile] [to] -o [outfile] ';


    MyDir      : DirStr = '';

    AskUnknown : Boolean = False;
    SigUnknown : Char    = 'A';     { A=Ask, N=No, Y=Yes }

    inFile     : String = '';
    outFile    : String = '';
    inName     : String = '';
    inTrigger  : String = '';

    SuppressPGP: Boolean = False;
    doSign     : Boolean = False;
    doEncr     : Boolean = False;
    doUsrID    : String[20]  = '';
    doWrap     : Word    = 78;

{$i timpgp.inc}

const
       Pos1        =#71;
       CrUp        =#72;
       PgUp        =#73;
       CrLe        =#75;
       CrRi        =#77;
       Ende        =#79;
       CrDn        =#80;
       PgDn        =#81;


{----------------------------------------------------------------------------}
Procedure AskEnter;
begin
     Write('[Any key]');
     MTReadKey;
end;
{----------------------------------------------------------------------------}
Procedure Deb( What : String );
begin
     WriteLn(What);
     WriteLn;
end;
{----------------------------------------------------------------------------}
Function ChoosePublicKey( var aDat : tPgpDat ) : Boolean;
{ Wenn True, dann Enter auf aDat gedrckt.. }

const max = 10;
var
    first, last, akt, oldakt, absmax: LongInt;
    Zeile  : Integer;
    fPub   : file of tPgpDat;
    aPub   : tPgpDat;


 Procedure NewPage;
 var i     : Word;
 begin
      GotoXY(1,Zeile);
      Last := first;
      Seek(fPub,first);
      While not Eof(fPub) and (last-first<max) do begin
            Read(fPub, aPub);
            If akt=last then textAttr:=lightgray*16;
            Write(PadR(aPub.ID,8)+''+PadR(TruncR(aPub.Name,50),50));
            ClrEol;WriteLn;
            If akt=last then textAttr:=lightgray;
            Inc(last);
      end;

      If last<first+max-1 then { Abfrage wegen VP Besonderheit bei for.. }
      for i := last to first+max-1 do begin
          ClrEol;WriteLn;
      end;
      Dec(last);
      oldakt := akt; { Balken-Update nicht mehr notwendig }
 end;

 Procedure Updatebar;
 begin
      Seek(fPub,oldakt);
      Read(fPub, aPub);
      GotoXY(1,oldakt-first+Zeile);
      TextAttr:=LightGray;
      Write(PadR(aPub.ID,8)+''+PadR(TruncR(aPub.Name,50),50));ClrEol;
      Seek(fPub,akt);
      Read(fPub, aPub);
      GotoXY(1,akt-first+Zeile);
      TextAttr:=LightGray*16;
      Write(PadR(aPub.ID,8)+''+PadR(TruncR(aPub.Name,50),50));ClrEol;
      OldAkt:=Akt;
      TextAttr:=LightGray;
 end;

var ch  : Char;

begin
     ChoosePublicKey := False;
     first:= 0; last:= 0; akt := 0; oldakt := 0;
     Assign(fPub,MyDir + 'timPGP.pub');
     SetFMode(OnlyRead);
     {$I-}Reset(fPub);{$I+}
     If IoResult <>0 then exit;
     absmax := filesize(fPub) - 1;

     TextAttr:=Yellow;
     Write(DuplChar('',80));
     TextAttr:=LightGray;
     NewPage;
     TextAttr:=Yellow;
     Write(DuplChar('',80));
     TextAttr:=White;
     Write(JustC('[ENTER] to choose, [ESC] to abort manual search',79));
     TextAttr:=LightGray;

     Zeile := WhereY -Max-1;

     Repeat
            ch := MTReadKey;
            if ch=#0 then begin
               ch := MTReadKey;
               case ch of
                 CrUp : If akt > first then Dec(akt)
                        else
                        if first>0 then begin
                           akt := first -1;
                           If first>=max then dec(first,max)
                           else first:=0;
                           Newpage;
                        end
                        else akt := 0;
                 CrDn : If akt < Last then Inc(akt)
                        else
                        If last<absmax then begin
                           first := last+1;
                           akt   := first;
                           Newpage;
                        end;
                 PgDn : If last<absmax then begin
                           first := last+1;
                           akt   := first;
                           Newpage;
                        end
                        else akt := last;
                 PgUp : if first>0 then begin
                           akt := first-1;
                           If first>=max then dec(first,max)
                           else first:=0;
                           Newpage;
                        end
                        else akt := 0;
               end;
            end;
            If oldakt<>akt then Updatebar;

     until Pos(ch,#13#27)>0;

     Seek(fPub, akt);
     Read(fPub,aDat);
     Close(fPub);

     GotoXY(1,Zeile+Max+1);
     TextAttr:=Lightgray;ClrEol;

     If ch=#13 then begin
        TextAttr := Lightred;
        Write('Do you want to assign ');
        TextAttr := White;
        Write(inName);
        TextAttr := Lightred;
        Write(' the public key ');
        TextAttr := White;
        Write(aDat.ID);
        TextAttr := Lightred;
        Write(' from now on ? (Y/n)');
        TextAttr := Lightgray;
        ch := UpCase(MTReadKey);
        WriteLn;
        ChoosePublicKey := ch<>'N';
     end;
end;
{----------------------------------------------------------------------------}
Procedure DoExec( What : String );
{$IfNDef VirtualPascal}
Var SwapField : TSwapMemSelect;
{$EndIf}
var c,p   : String;
    po    : Byte;
begin
     po := Pos(#32,what);
     If po>0 then begin
        c:=Copy(What,1,po-1);
        delete(What,1,po);
        p := What;
     end
     else begin
          c := What;
          p := '';
     end;
     {$IfNDef VirtualPascal}
     { SetMemTop(HeapPtr); }
     SwapVectors;
     SwapField [1] := EMS;
     SwapField [2] := XMS;
     SwapField [3] := DISK;
     Deb('DoExec: '+c+' '+p);
     If not ExecSwap(HeapEnd,SwapField,c,p) then DosError := 255
     else DosError := DosRetValue;

     If DosError>0 then Deb('Fehler bei Exec '+NumStr(DosError));

     SwapVectors;
     { SetMemTop(HeapEnd); }
     {$Else}
     Exec(c,p);
     {$EndIf}
end;
(* ----------------------------------------------------------------------- *)
Procedure ReadConfig;
Var Command, What, Line : String;
    fCfg                : Text;
    vc                  : Integer;

Function SplitLine: Boolean;
var Sp   : Word;
begin
     SplitLine := False;
     Sp:=Pos(';',Line);
     if Sp>0 then Line[0]:=char(Pred(Sp));
     Line:=TrimL(TrimR(Replace(Line,#9,#32)));
     If Line='' then exit;
     Sp:=Pos(#32,Line);
     If Sp=0 then begin
        Command:=UpperCase(Line);
        What:='';
     end
     else begin
         Command:=UpperCase(Copy(Line,1,Pred(Sp)));
         Delete(Line,1,Sp);
         Line:=TrimL(Line);
         What:=Line;
     end;
     SplitLine:=True;
end;

 Function Str2Nummer( S : String ):LongInt;
 var N    : LongInt;
     vc   : Integer;
 begin
      Val(S,N,vc);
      Str2Nummer:=N;
 end;

 Procedure SplitWhat( W :String; var S1, S2 : String);
 var P     : Word;
 begin
      S1:=''; S2:='';
      P:=Pos(#32,W);
      If P=0 then begin
         S1:=W;
         exit;
      end;
      s1:=TrimR(TrimL(Copy(w,1,p-1)));
      s2:=TrimR(TrimL(Copy(w,p+1,255)));
 end;

 Procedure Interpret;
 var i     : Word;
 begin
      {$IfDef VirtualPascal}
      {$Ifdef OS2}
      If Command='OS2PGP'     then strPgp      := What      else
      {$Else}
      If Command='W32PGP'     then strPgp      := What      else
      {$Endif}
      {$Else}
      If Command='DOSPGP'     then strPgp      := What      else
      {$EndIf}
      If Command='PUBRING'    then strPubRing  := What      else
      If Command='MANTRA'     then strMantra   := What      else
      If Command='PUBID'      then strPubID    := What      else
      If Command='TRIGGER'    then strTrigger  := What+','  else
      If Command='ENCALWTO'   then strEncrID   := What      else
      If Command='SUPRESSPGP' then SuppressPGP := True      else
      If Command='SIGUNKNOWN' then SigUnknown  := Upcase(What[1]) else
      If Command='ASKUNKNOWN' then AskUnknown  := True      else
      If Command='ASKIFUSER'  then strAskUser  := What;
 end;

 begin { ReadConfig }
     Assign(fCfg,MyDir+'TIMPGP.CFG');
     {$I-}Reset(fCfg);{$I+}
     If IoResult<>0 then begin
        WriteLn('Didn''t find TIMPGP.CFG');
        WriteLn('How about a small configuration job ? :-)'#7);
        Halt(2);
     end;
     While not Eof(fCfg) do begin
           ReadLn(fCfg,Line);
           If SplitLine then Interpret;
     end;
     Close(fCfg);

     If strMantra<>'' then parMantra := '-z "'+strMantra+'"';
end;

(* ----------------------------------------------------------------------- *)
Procedure Init;
var N : NameStr;
    E : ExtStr;
    PgpPath : String;
begin
     FSplit(ParamStr(0),MyDir, N, E);
     PgpPath := GetEnv('PGPPATH');
     If (PgpPath[Length(PgpPath)]<>'\') and (Length(PgpPath)>0) then
        PgpPath := PgpPath + '\';
     strPgp := PgpPath + strPgp;

     {strMantra := GetEnv('PGPPASS'); Doppeltgemoppelt und man sieht es dann}
end;

(* ----------------------------------------------------------------------- *)
Procedure ValidateUsrFile;
{ berprft, ob alle gespeicherten User noch im Public file gefunden werden.
  Wenn nicht, dann wird der entsprechende User gelscht. }
var aUsr : tUserDat;
    fUsr, ftmp : file of tUserDat;
    aDat : tPgpDat;
    fDat : file of tPgpDat;
    found : boolean;
begin
     Writeln('Validating user datafile...');
     SetFMode(OnlyRead);
     Assign(fDat,MyDir +'timPGP.pub');
     {$I-}Reset(fDat);{$I+}
     If IoResult<>0 then exit;

     Assign(fUsr,MyDir + 'timPGP.usr');
     Assign(fTmp,MyDir + 'timPGP.u$r');
     {$I-}Reset(fUsr);{$I+}
     If IoResult=0 then begin
        SetFMode(OnlyWrite);
        Rewrite(fTmp);
        While not Eof(fUsr) do begin
              Read(fUsr,aUsr);
              found := false;
              Seek(fDat,0);
              While not Eof(fDat) and not found do begin
                    read(fDat,aDat);
                    found := (aUsr.id = aDat.id);
              end;
              if found then write(fTmp,aUsr);
        end;

        Close(fUsr);
        Close(fTmp);
        {$i-}
        Erase(fUsr);
        Rename(fTmp,MyDir + 'timPGP.usr');
        {$i+}
        If IoResult <> 0 then WriteLn('Validating didn''t work correctly..');

     end;

     Close(fDat);
end;
(* ----------------------------------------------------------------------- *)
Procedure CompilePubRing;
var fCfg : Text;
    Line : String;
    dat  : tPgpDat;
    fDat : file of tPgpDat;
    foundone : Boolean;
    dPub, dDat : LongInt;
    dtPub, dtDat : DateTime;
    tmp        : String;
begin
     If strPubRing<>'' then begin
        Assign(fDat,strPubRing);
        SetFMode(ReadWrite);
        {$I-}Reset(fDat);{$I+}
        If IoResult<>0 then begin
           TextAttr := LightRed;
           WriteLn('Error reading '+strPubRing);
           TextAttr := LightGray;
           Halt;
        end;
        GetFTime(fDat, dPub);
        UnpackTime(dPub,dtPub);
        Close(fDat);

        Assign(fDat,MyDir +'timPGP.pub');
        SetFMode(ReadWrite);
        If FSize(MyDir +'timPGP.pub')>0 then begin { =0 : Neu machen ! }
           {$I-}Reset(fDat);{$I+}
           If IoResult=0 then begin
              GetFTime(fDat, dDat);
              UnpackTime(dDat,dtDat);
              Close(fDat);
              if TagesZahl(dtPub) < TagesZahl(dtDat) then exit;
           end
        end;
     end;

     WriteLn;

     { Unter Win95 klappt das normale > nicht mit Batch files. Mit SetOutput
       kann ich wieder batches verwenden ! }
     {$ifndef VirtualPascal}
     SetOutput(MyDir+'timPGP.$$$');
     DoExec(GetEnv('COMSPEC')+ ' /C '+strPgp+ ' '+parMantra+' -kv '+strPubRing);
     CancelOutput;
     {$else}
     { Unter OS/2 gibt's kein Problem mit Batch-Redirection... }
     DoExec(GetEnv('COMSPEC')+ ' /C '+strPgp+ ' '+parMantra+' -kv '+strPubRing+' >'+MyDir+'timPGP.$$$');
     {$endif}

     SetFMode(OnlyRead);
     Assign(fCfg,MyDir+'TIMPGP.$$$');
     {$I-}Reset(fCfg);{$I+}
     If IoResult<>0 then begin
        TextAttr := LightRed;
        WriteLn('Error while executing PGP');
        TextAttr := LightGray;
        halt;
     end;

     FoundOne := False;
     Assign(fDat, MyDir + 'timPGP.pub');
     SetFMode(OnlyWrite);
     Rewrite(fDat);
     While not eof(fCfg) do begin
           ReadLn(fCfg,Line);
           If Pos(strPubID+' ',Line)=1 then begin
              tmp := line;
              tmp := Copy(tmp,5,5);
              tmp := TrimL(tmp);
              Fillchar(dat, SizeOf(dat), 0);
              dat.size := TrimL(Copy(Line,5,5));
              dat.ID   := Copy(Line,11,8);
              dat.date := Copy(Line,20,10);
              Delete(Line,1,30);
              dat.Name := Line;
              FoundOne := True;
              Write(fDat,dat);
           end else
           If FoundOne and (Pos(PadR('',30),Line)=1) then begin
              Delete(Line,1,30);
              dat.Name := Line;
              Write(fDat,dat);
           end;
     end;
     Close(fCfg);
     Close(fDat);
     Erase(fCfg);

     { Nach der compilierung berprfen, ob ein User in der usr so nicht
       mehr vorhanden ist }
     ValidateUsrFile;
end;
(* ----------------------------------------------------------------------- *)
Procedure Help;
begin
     TextAttr := Lightcyan;
     WriteLn('Compiled on '+compiledon);
     Textattr := Lightgray;
     WriteLn;
     Writeln('usage: timPGP [options]');
     WriteLn;
     WriteLn('Options:');
     WriteLn('/n   The complete name in the "to" field of the message should follow');
     WriteLn('/i   The name of the original textfile, saved by your message editor');
     WriteLn('/o   The name of the changed textfile handed back by timPGP');
     WriteLn('/t   Any trigger, timPGP should react on, e.g. netmail/echomail');
     WriteLn;
     WriteLn('Example:');
     WriteLn('timPGP /n Grischa Brockhaus /i c:\tmp\timed.msg /o c:\tmp\timed.new');
     Halt;
end;
(* ----------------------------------------------------------------------- *)
Procedure ReadPars;
var i     : word;
    h     : String;
begin
     If ParamCount = 0 then Help;
     i := 1;
     While i<=ParamCount do begin
           H := Uppercase(ParamStr(i));
           inc(i);

           If H = '/N' then begin
              inName := '';
              Repeat
                    H := ParamStr(i);
                    If (i<=ParamCount) and (H[1]<>'/') then
                       inName := inName +' '+ H;
                    Inc(i);
              until (i>ParamCount) or (H[1]='/');
              dec(i);
              inName := TrimL(InName);
           end else
           If H ='/I' then begin
              inFile := ParamStr(i);
              Inc(i);
           end;
           If H ='/O' then begin
              outFile := ParamStr(i);
              Inc(i);
           end;
           If H ='/T' then begin
              inTrigger := ParamStr(i);
              Inc(i);
           end;
     end;
     If InName = '' then Help;

     If (strTrigger<>'') and (inTrigger<>'') and (Pos(Uppercase(inTrigger)+',',Uppercase(strTrigger))=0)
        then begin
        textattr:=lightred;
        WriteLn('Wrong trigger "'+inTrigger+'". Exiting...');
        textattr:=lightgray;
        Halt;
     end;

     If inFile='' then begin
        WriteLn('Need some file to work on...');
        Halt;
     end;

     WriteLn;
     If inTrigger<>'' then begin
        TextAttr := LightCyan;
        Write('Triger: ');
        TextAttr := White;
        WriteLn(inTrigger);
     end;
     TextAttr := LightCyan;
     Write('User  : ');
     TextAttr := White;

     { AskIfUser }
     if inName = strAskUser then
       ReadLn(inName)
     else
       WriteLn(inName);
     TextAttr := LightGray;
end;
(* ----------------------------------------------------------------------- *)
Procedure SearchUsr;
var aUsr : tUserDat;
    fUsr : file of tUserDat;
    aDat : tPgpDat;
    fDat : file of tPgpDat;
    found,
    pFound : Boolean;
    HN, HA : String;

 Procedure AskAttr;
 var c  : char;
 begin
      TextAttr := LightCyan;
      Write('Sign  : ');
      TextAttr := White;
      If aUsr.sign = usrAsk then begin
         TextAttr := Yellow;
         Write('Y');
         TextAttr := White;
         Write('es/');
         TextAttr := Yellow;
         Write('N');
         TextAttr := White;
         Write('o/');
         TextAttr := Yellow;
         Write('A');
         TextAttr := White;
         Write('lways/ne');
         TextAttr := Yellow;
         Write('V');
         TextAttr := White;
         Write('er ? ');
         repeat
            c := UpCase(MTReadKey);
         until Pos(c,'YNAV')>0;
         WriteLn(c);
         doSign := Pos(c,'YA')>0;
         If c='A' then aUsr.sign := usrAlways else
         If c='V' then aUsr.sign := usrNever  else
         aUsr.sign := usrAsk;
      end else
      If aUsr.sign = usrAlways then begin
         WriteLn('Always');
         doSign := True;
      end else
      If aUsr.sign = usrNever then begin
         WriteLn('Never');
         doSign := False;
      end;


      TextAttr := LightCyan;
      Write('Encr. : ');
      TextAttr := White;
      If aUsr.enc = usrAsk then begin
         TextAttr := Yellow;
         Write('Y');
         TextAttr := White;
         Write('es/');
         TextAttr := Yellow;
         Write('N');
         TextAttr := White;
         Write('o/');
         TextAttr := Yellow;
         Write('A');
         TextAttr := White;
         Write('lways/ne');
         TextAttr := Yellow;
         Write('V');
         TextAttr := White;
         Write('er ? ');
         repeat
            c := UpCase(MTReadKey);
         until Pos(c,'YNAV')>0;
         WriteLn(c);
         doEncr := Pos(c,'YA')>0;
         If c='A' then aUsr.enc := usrAlways else
         If c='V' then aUsr.enc := usrNever  else
         aUsr.enc := usrAsk;
      end else
      If aUsr.enc = usrAlways then begin
         WriteLn('Always');
         doEncr := True;
      end else
      If aUsr.enc = usrNever then begin
         WriteLn('Never');
         doEncr := False;
      end;

      TextAttr := LightGray;
 end;

 Procedure NewUser;
 begin
      FillChar(aUsr, SizeOf(aUsr), 0);
      aUsr.Name := inName;
      aUsr.id   := aDat.ID;
      AskAttr;
 end;

var MerkSeeker : LongInt;

begin
     found  := False;

     Assign(fUsr,MyDir + 'timPGP.usr');
     SetFMode(OnlyRead);
     {$I-}Reset(fUsr);{$I+}
     If IoResult=0 then begin
        MerkSeeker := -1;
        While not found and not Eof(fUsr) do begin
              Inc(MerkSeeker);
              Read(fUsr,aUsr);
              found := (aUsr.Name = inName);
        end;
        Close(fUsr);
     end;

     If not found then begin
        pfound := False;
        WriteLn('User not found in userfile, searching for public pgp key..');
        HN := UpperCase(inName);
        Assign(fDat,MyDir + 'timPGP.pub');
        SetFMode(OnlyRead);
        {$I-}Reset(fDat);{$I+}
        If IoResult=0 then begin
           While not pFound and not Eof(fDat) do begin
                 Read(fDat, aDat);
                 If Pos(HN, UpperCase(aDat.Name)) <> 0 then begin
                    Write('Is it ');
                    TextAttr := White;
                    Write(aDat.Name);
                    TextAttr := LightGray;
                    WriteLn(' ? (y/N)');
                    pFound := UpCase(MTReadKey) = 'Y';
                 end;
           end;
           Close(fDat);

           { Wenn kein automatisch passender Key da ist, dann manuell suchen
             lasssen }
           If not pFound then
              if AskUnknown then begin
                 WriteLn('No matching public key found, do you want to assign one manualy ? (y/N)');
                 If UpCase(MTReadKey) = 'Y' then
                    pFound := ChoosePublicKey( aDat );
              end
              else WriteLn('Sorry, no public key found for this user...');

           { Wenn okay, dann eintragen ! }
           If pFound then begin
              NewUser;
              SetFMode(OnlyWrite);
              {$I-}Reset(fUsr);{$I+}
              If IoResult<>0 then Rewrite(fUsr);
              Seek(fUsr,FileSize(fUsr));
              Write(fUsr,aUsr);
              Close(fUsr);
           end
           else begin
                Case SigUnknown of
                  'Y','J' : doSign := true;
                  'N'     : doSign := false;
                  else begin
                    WriteLn('Do you want to sign the mail ? (y/N)');
                    If UpCase(MTReadKey) = 'Y' then doSign := true;
                  end
                end; { Case }
           end;
        end;
     end
     else { found } begin
          AskAttr;
          SetFMode(OnlyWrite);
          {$I-}Reset(fUsr);{$I+}
          Seek(fUsr,MerkSeeker);
          Write(fUsr,aUsr);
          Close(fUsr);
     end;

     doUsrID := aUsr.ID;
end;
(* ----------------------------------------------------------------------- *)
type TCharBuff = Array[1..3000] of Char;
type PCharBuff = ^TCharBuff;

Function PreprocessFile( Wich : String ): Boolean;
var fIn  : File;
    fOut : File;
    pBuff   : PCharBuff;
    LF      : String[2];
    Start, Ende : Word;
    LastSpace   : Word;
    numread : Word;
begin
     PreprocessFile := False;
     WriteLn('Converting LineFeed...');
     LF := #13#10;

     Assign(fIn ,Wich);
     SetFMode(ReadWrite);
     {$I-}Reset(fIn,1);{$I+}
     If IoResult<>0 then Exit;

     Assign(fOut,MyDir+'timpgp.$$a');
     SetFMode(ReadWrite);
     {$I-}Rewrite(fOut,1);{$I+}
     If IoResult<>0 then begin
        Close(fIn);
        TextAttr := Lightred;
        WriteLn(#7'Error opening temp. file '+MyDir+'timpgp.$$a');
        TextAttr := LightGray;
        AskEnter;
        Exit;
     end;
     New(pBuff);
     While not Eof(fIn) do begin
           Start := 1;
           Ende  := 1;
           Blockread(fIn,pBuff^,SizeOf(pBuff^),Numread);

           If Start = 1 then begin
              If (UpCase(pBuff^[2])='C') and (UpCase(pBuff^[3])=':') and (
                   (UpCase(pBuff^[1])='X') or
                   (UpCase(pBuff^[1])='C') or
                   (UpCase(pBuff^[1])='H')
                 ) then begin
                      Dispose(pBuff);
                      Close(fIn);
                      Close(fOut);
                      DelFile(MyDir+'timpgp.$$a');
                      TextAttr := Lightred;
                      WriteLn(#7'CC:, HC: and XC: can''t be crypted yet. Aborting.');
                      TextAttr := LightGray;
                      AskEnter;
                      Exit;
              end;
           end;

           { wrapping and replacement of #$0D with #$0D#$0A }
           While Ende<Numread do begin
                 LastSpace := 0;
                 While (pBuff^[Ende]<>LF[1]) and (Ende<NumRead) do begin
                       If (Ende<=Start+doWrap) and (pBuff^[Ende]=#32) then LastSpace := Ende;
                       Inc(Ende);
                 end;
                 If (Ende>Start+doWrap) and (LastSpace >0) then Ende := LastSpace;
                 BlockWrite(fOut,pBuff^[Start],Ende-Start);
                 BlockWrite(fOut,LF[1],2);
                 Inc(Ende);
                 If pBuff^[Ende]=LF[2] then Inc(Ende);
                 Start := Ende;
           end;
     end;
     Dispose(pBuff);
     Close(fIn);
     Close(fOut);
     DelFile(Wich);
     {$I-}Rename(fOut,Wich);{$I+}
     If IoResult<>0 then begin
        CopyFile( MyDir+'timpgp.$$a', Wich );
        Delfile( MyDir+'timpgp.$$a' );
     end;

     PreprocessFile := True;
end;
(* ----------------------------------------------------------------------- *)
Procedure LetsGo;
var par   : String;
    fTmp  : File;
    parNul : String;
    viaStr : String;
begin
     If doEncr and doSign then par := parEncSig else
     If doEncr            then par := parEnc    else
     If doSign            then par := parSig    else
     exit;

     DelFile(MyDir+'timpgp.$$$');
     If IoResult<>0 then;

     If not PreprocessFile( Infile ) then Exit;
     par := ReplaceStr(par,'[to]','0x'+doUsrID+' '+strEncrID);
     par := ReplaceStr(par,'[infile]',inFile);
     par := ReplaceStr(par,'[outfile]',MyDir+'timpgp.$$$');
     {WriteLn(strPgp+' '+par);}
     WriteLn;

     {$IfnDef VirtualPascal}
     If SuppressPGP then SetOutput(MyDir+'pgpout.$$$');
     DoExec(GetEnv('COMSPEC')+' /C '+strPgp+' '+par+' '+parMantra);
     If SuppressPGP then CancelOutput;
     {$Else}
     If SuppressPGP then parNul := ' >'+MyDir+'pgpout.$$$'
     else parNul := '';
     DoExec(GetEnv('COMSPEC')+' /C '+strPgp+' '+par+' '+parMantra+parNul);
     {$EndIf}

     WriteLn;
     If SuppressPGP then DelFile(MyDir+'pgpout.$$$');
     If IoResult<>0 then;
     Assign(fTmp,MyDir+'timpgp.$$$');
     SetFMode(ReadWrite);
     {$I-}Reset(fTmp,1);{$I+}
     If IoResult<>0 then begin
        TextAttr:=LightRed;
        WriteLn('Error while executing pgp..');
        TextAttr:=LightGray;
        Halt;
     end;
     Seek(fTmp,FileSize(fTmp));

     viaStr := UTCTimeStr+' by timPGP V.'+Version;

     Blockwrite(fTmp,viaStr[1],Length(viaStr));
     Close(fTmp);
     If outFile='' then outfile:=infile;
     DelFile(outFile);
     If IoResult<>0 then;

     {$I-}Rename(fTmp,outFile);{$I+}
     If IoResult<>0 then begin
        CopyFile( MyDir+'timpgp.$$$', outFile );
        Delfile( MyDir+'timpgp.$$$' );
        If IoResult<>0 then begin
           TextAttr:=LightRed;
           WriteLn('Troubles while renaming files.. :-(');
        end
        else begin
           TextAttr:=Lightgreen;
           WriteLn('Success.');
        end;
     end
     else begin
          TextAttr:=Lightgreen;
          WriteLn('Success.');
     end;
end;
(* ----------------------------------------------------------------------- *)
begin
     ClrScr;
     TextAttr := White;
     Write  ('timPGP '+Version);
     {$IfDef VirtualPascal}
     {$IfDef OS2}
     Write  ('');
     {$Else}
     Write  ('W');
     {$Endif}
     {$EndIf}
     WriteLn('   (C)opyright 1999 by Andre Grueneberg under GNU GPL v2.0+');
     TextAttr := Yellow;
     WriteLn('Freeware Interface    timEd -> PGP 2.6.x');
     TextAttr := LightGray;
     Init;
     ReadConfig;
     CompilePubRing;
     ReadPars;
     SearchUsr;
     LetsGo;
     TextAttr:=LightGray;
end.
