(*
Copyright (C) 1999 Grischa Brockhaus <skullsoft@grischa.de>
modified      1999 Andre Grueneberg <andre@grueneberg.de>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*)

uses crt, ustring, share, MTask;
{$i timpgp.inc}

const
       Pos1        =#71;
       CrUp        =#72;
       PgUp        =#73;
       CrLe        =#75;
       CrRi        =#77;
       Ende        =#79;
       CrDn        =#80;
       PgDn        =#81;

       MyDir       : String = '';

var
    first, last, akt, oldakt: LongInt;

{----------------------------------------------------------------------------}
Function ChoosePublicKey : Boolean;
{ Wenn True, dann Enter auf aDat gedrckt.. }

var aDat : tUserDat;

const max = 20;

var
    absmax : LongInt;
    Zeile  : Integer;
    fPub   : file of tuserDat;
    fTmp   : file of tuserDat;
    aPub   : tUserDat;


 Procedure NewPage;
 var i     : Word;
 begin
      GotoXY(1,Zeile);
      Last := first;
      Seek(fPub,first);
      While not Eof(fPub) and (last-first<max) do begin
            Read(fPub, aPub);
            If akt=last then textAttr:=lightgray*16;
            Write(PadR(TruncR(aPub.Name,55),55)+''+PadR(aPub.ID,8)+'');

            Case aPub.sign of
              usrAsk    : Write(PadR('Ask',6));
              usrNever  : Write(PadR('Never',6));
              usrAlways : Write(PadR('Always',6));
            end;
            Write('');
            Case aPub.enc of
              usrAsk    : Write(PadR('Ask',6));
              usrNever  : Write(PadR('Never',6));
              usrAlways : Write(PadR('Always',6));
            end;
            Write('');

            ClrEol;WriteLn;
            If akt=last then textAttr:=lightgray;
            Inc(last);
      end;

      If last<first+max-1 then { Abfrage wegen VP Besonderheit bei for.. }
      for i := last to first+max-1 do begin
          ClrEol;WriteLn;
      end;
      Dec(last);
      oldakt := akt; { Balken-Update nicht mehr notwendig }
 end;

 Procedure Updatebar;
 begin
      Seek(fPub,oldakt);
      Read(fPub, aPub);
      GotoXY(1,oldakt-first+Zeile);
      TextAttr:=LightGray;
      Write(PadR(TruncR(aPub.Name,55),55)+''+PadR(aPub.ID,8)+'');ClrEol;
      Case aPub.sign of
        usrAsk    : Write(PadR('Ask',6));
        usrNever  : Write(PadR('Never',6));
        usrAlways : Write(PadR('Always',6));
      end;
      Write('');
      Case aPub.enc of
       usrAsk    : Write(PadR('Ask',6));
       usrNever  : Write(PadR('Never',6));
       usrAlways : Write(PadR('Always',6));
      end;
      Write('');
      Seek(fPub,akt);
      Read(fPub, aPub);
      GotoXY(1,akt-first+Zeile);
      TextAttr:=LightGray*16;
      Write(PadR(TruncR(aPub.Name,55),55)+''+PadR(aPub.ID,8)+'');ClrEol;
      Case aPub.sign of
        usrAsk    : Write(PadR('Ask',6));
        usrNever  : Write(PadR('Never',6));
        usrAlways : Write(PadR('Always',6));
      end;
      Write('');
      Case aPub.enc of
       usrAsk    : Write(PadR('Ask',6));
       usrNever  : Write(PadR('Never',6));
       usrAlways : Write(PadR('Always',6));
      end;
      Write('');
      OldAkt:=Akt;
      TextAttr:=LightGray;
 end;

var ch  : Char;
    l   : longint;

begin
     GotoXY(1,1);
     ChoosePublicKey := False;
     Assign(fPub,MyDir + 'timPGP.usr');
     SetFMode(OnlyRead);
     {$I-}Reset(fPub);{$I+}
     If IoResult <>0 then begin
        WriteLn('No '+MyDir+'timPGP.usr found. I have nothing to edit.');
        WriteLn;
        exit;
     end;
     absmax := filesize(fPub) - 1;
     If absmax = -1 then begin
        WriteLn(MyDir+'timPGP.usr doesn''t contain an entry.');
        WriteLn;
        Close(fPub);
        exit;
     end;

     TextAttr:=White;
     WriteLn(PadR(TruncR('Name',55),55)+''+PadR('use key',8)+''+PadR(' Sign',6)+''+PadR(' Encr',6)+'');
     TextAttr:=Yellow;
     Write(DuplChar('',80));
     TextAttr:=LightGray;
     NewPage;
     TextAttr:=Yellow;
     Write(DuplChar('',80));
     TextAttr:=White;
     Write(JustC('[ENTER] to delete, [ESC] to quit',79));
     TextAttr:=LightGray;

     Zeile := WhereY -Max-1;

     Repeat
            ch := MTReadKey;
            if ch=#0 then begin
               ch := MTReadKey;
               case ch of
                 CrUp : If akt > first then Dec(akt)
                        else
                        if first>0 then begin
                           akt := first -1;
                           If first>=max then dec(first,max)
                           else first:=0;
                           Newpage;
                        end
                        else akt := 0;
                 CrDn : If akt < Last then Inc(akt)
                        else
                        If last<absmax then begin
                           first := last+1;
                           akt   := first;
                           Newpage;
                        end;
                 PgDn : If last<absmax then begin
                           first := last+1;
                           akt   := first;
                           Newpage;
                        end
                        else akt := last;
                 PgUp : if first>0 then begin
                           akt := first-1;
                           If first>=max then dec(first,max)
                           else first:=0;
                           Newpage;
                        end
                        else akt := 0;
               end;
            end;
            If oldakt<>akt then Updatebar;

     until Pos(ch,#13#27)>0;

     Seek(fPub, akt);
     Read(fPub,aDat);
     Close(fPub);

     GotoXY(1,Zeile+Max+1);
     TextAttr:=Lightgray;ClrEol;

     If ch=#13 then begin
        TextAttr := Lightred;
        Write('Do you want to delete ');
        TextAttr := White;
        Write(aDat.Name+', '+aDat.ID);
        TextAttr := Lightred;
        Write(' from user configuration ? (Y/n)');
        TextAttr := Lightgray;
        ch := UpCase(MTReadKey);
        ChoosePublicKey := True;
        if (ch<>'n') and (ch<>'N') then begin
           Assign(fTmp,MyDir + 'timPGP.u$r');
           SetFMode(ReadWrite);
           Rewrite(fTmp);
           SetFMode(OnlyRead);
           Reset(fPub);
           l := 0;
           While not Eof(fPub) do begin
                 Read(fPub,aDat);
                 If l<>akt then write(fTmp,aDat);
                 inc(l);
           end;
           ChoosePublicKey :=  l>1; { Es war mehr als 1 Eintrag vor dem Lschen da }
           Close(fPub);
           Close(fTmp);
           Erase(fPub);
           Rename(fTmp,MyDir + 'timPGP.usr');
           If akt>0 then dec(akt)
        end;
        WriteLn;
     end;
end;
{----------------------------------------------------------------------------}
begin
     ClrScr;
     first:= 0; last:= 0; akt := 0; oldakt := 0;
     while ChoosePublicKey do;
end.
